"""
Django settings for unchained project.

Generated by 'django-admin startproject' using Django 2.2.4.

For more information on this file, see
https://docs.djangoproject.com/en/stable/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/stable/ref/settings/
"""

import os
import sys

import sentry_sdk
from django.utils.translation import gettext_lazy as _
from dotenv import load_dotenv
from sentry_sdk.integrations.django import DjangoIntegration

load_dotenv(override=True)

# Build paths inside the project like this: os.path.join(BASE_DIR, ...)
BASE_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))


# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/stable/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = "4w4tt0fda2s+j!sj#ervtgk_2w#nal-=!i#z_j82j1u-!tqb_9"

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = True


# Setting up for mollie
if DEBUG:
    MOLLIE_API_KEY = os.environ.get("MOLLIE_API_TEST_KEY", "test_test")
else:
    BASE_URL = "www.a-eskwadraat.nl"
    MOLLIE_API_KEY = os.environ.get("MOLLIE_API_KEY", "test_test")

BASE_URL = "http://localhost:8000"

DEV_SERVER = len(sys.argv) > 1 and sys.argv[1] == "runserver"
# since we shouldn't be using the runserver command in deployment,
# we can assume that any time it is the first argument, we're developing.

USE_NGROK = (
    os.environ.get("USE_NGROK", "False") == "True"
    and os.environ.get("RUN_MAIN", None) != "true"
    # lowercase t, cus apparently thats what django sets it to
)
# we wanna use ngrok when:
# - we say so (USE_NGROK == "True"), AND
# - this is the first of the django processes we start (RUN_MAIN != "true")
# We want this second condition because we only want to start a tunnel once.

# the reason why this condition tests if this is the first process we start
# is complicated. it has to do with the way Django watches for changes,
# and reloads when it sees any.
# for more info: see https://programmersought.com/article/49721374106/

if DEV_SERVER and USE_NGROK:
    from .setup_ngrok import get_ngrok_connection

    # the import is here to make sure ngrok is only started when we want to use it.
    # (setup_ngrok starts ngrok on import)
    BASE_URL = get_ngrok_connection().public_url

ALLOWED_HOSTS = [".localhost", "127.0.0.1", "[::]", ".a-eskwadraat.nl", ".ngrok.io"]

# Send errors to Sentry if we're not in debug mode.
# In debug mode we can just see them on the screen in front of us (or in the terminal running the server),
# and we don't want to annoy other people with the debug errors.
if not DEBUG:
    sentry_sdk.init(
        dsn="https://7af72be9bed24d3e9c499a2abd29c1f7@o226068.ingest.sentry.io/5463967",
        integrations=[DjangoIntegration()],
        traces_sample_rate=1.0,
        # If you wish to associate users to errors (assuming you are using
        # django.contrib.auth) you may enable sending PII data.
        send_default_pii=False,
    )

# Application definition

INSTALLED_APPS = [
    # Our own apps
    "activities",
    "career",
    "groups",
    "ideal",
    "members",
    "news",
    "authentication",
    "docuweb",
    "achievements",
    "fixtures",
    "wrinklypages",
    # The default set of apps
    "django.contrib.admin",
    "django.contrib.auth",
    "django.contrib.contenttypes",
    "django.contrib.sessions",
    "django.contrib.messages",
    "django.contrib.staticfiles",
    # Other dependencies.
    "bulma",
    "debug_toolbar",
    "django_countries",
    "django.contrib.sites",
    "django.contrib.flatpages",
    "django.contrib.admindocs",
    "guardian",
    "phonenumber_field",
    "webpack_loader",
    "widget_tweaks",
    "sitetree",
    "django.contrib.auth.context_processors",
    "tinymce",
]

MIDDLEWARE = [
    "debug_toolbar.middleware.DebugToolbarMiddleware",
    "django.middleware.security.SecurityMiddleware",
    "django.contrib.sessions.middleware.SessionMiddleware",
    "django.middleware.locale.LocaleMiddleware",
    "django.middleware.common.CommonMiddleware",
    "django.middleware.csrf.CsrfViewMiddleware",
    "django.contrib.auth.middleware.AuthenticationMiddleware",
    "django.contrib.messages.middleware.MessageMiddleware",
    "django.middleware.clickjacking.XFrameOptionsMiddleware",
    "wrinklypages.middleware.WrinklyMiddleware",  # this is used to serve wrinklypages and to do dynamic redirects
]

ROOT_URLCONF = "unchained.urls"

TEMPLATES = [
    {
        "BACKEND": "django.template.backends.django.DjangoTemplates",
        "DIRS": [os.path.join(BASE_DIR, "templates")],
        "APP_DIRS": True,
        "OPTIONS": {
            "context_processors": [
                "django.template.context_processors.debug",
                "django.template.context_processors.request",
                "django.contrib.auth.context_processors.auth",
                "django.contrib.messages.context_processors.messages",
            ]
        },
    }
]

# for ease of transitioning to div-based forms (which will be default by django 5.0).
# this will be depricated by django 5.0 and should be removed by django 6.0
FORM_RENDERER = "django.forms.renderers.DjangoDivFormRenderer"

WSGI_APPLICATION = "unchained.wsgi.application"

TINYMCE_DEFAULT_CONFIG = {
    "theme": "silver",
    "height": 500,
    "menubar": False,
    "plugins": "advlist,autolink,lists,link,image,charmap,print,preview,anchor,"
    "searchreplace,visualblocks,code,fullscreen,insertdatetime,media,table,paste,"
    "codesample,help,wordcount,spellchecker",
    "toolbar": "undo redo | bold italic underline strikethrough | fontselect fontsizeselect formatselect | alignleft "
    "aligncenter alignright alignjustify | outdent indent |  numlist bullist | forecolor "
    "backcolor casechange | charmap | "
    "fullscreen  preview | image link anchor codesample | code",
    "custom_undo_redo_levels": 10,
    "skin": "oxide-dark",
    "content_css": "dark",
}

# Authentication

AUTHENTICATION_BACKENDS = [
    "authentication.backends.MemberBackend",
    "guardian.backends.ObjectPermissionBackend",
]
AUTH_USER_MODEL = "authentication.User"
LOGIN_URL = "/accounts/login/"
LOGIN_REDIRECT_URL = "/leden/ingelogd/"
LOGOUT_REDIRECT_URL = "/home/"

ANONYMOUS_USER_NAME = "AnonymousUser"
GUARDIAN_GET_INIT_ANONYMOUS_USER = "authentication.models.create_anonymous_user"
GUARDIAN_MONKEY_PATCH = False

# Database
# https://docs.djangoproject.com/en/stable/ref/settings/#databases

DATABASES = {
    "default": {
        "ENGINE": "django.db.backends.sqlite3",
        "NAME": os.path.join(BASE_DIR, "db.sqlite3"),
    }
}


# Password validation
# https://docs.djangoproject.com/en/stable/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        "NAME": "django.contrib.auth.password_validation.UserAttributeSimilarityValidator"
    },
    {"NAME": "django.contrib.auth.password_validation.MinimumLengthValidator"},
    {"NAME": "django.contrib.auth.password_validation.CommonPasswordValidator"},
    {"NAME": "django.contrib.auth.password_validation.NumericPasswordValidator"},
]


# Internationalization
# https://docs.djangoproject.com/en/stable/topics/i18n/

LANGUAGE_CODE = "nl"

TIME_ZONE = "UTC"

USE_I18N = True

USE_L10N = True

USE_TZ = True

DATE_FORMAT = "Y-m-j"
DATETIME_FORMAT = "Y-m-j, H:m:s"

LOCALE_PATHS = [os.path.join(BASE_DIR, "locale")]

LANGUAGES = [("nl", _("Dutch")), ("en", _("English"))]

# Phonenumber Internationalization
# see https://django-phonenumber-field.readthedocs.io/en/latest/reference.html#settings

PHONENUMBER_DEFAULT_REGION = "NL"


# Media
# https://docs.djangoproject.com/en/stable/topics/files/

MEDIA_ROOT = os.path.join(BASE_DIR, "media")

MEDIA_URL = "/media/"

# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/stable/howto/static-files/

STATIC_URL = "/static/"

STATICFILES_DIRS = [os.path.join(BASE_DIR, "assets")]
if not DEBUG:
    STATICFILES_DIRS.append("/var/www/static/")

# Fixture files

FIXTURE_DIRS = (
    os.path.join(BASE_DIR, "fixtures/fixtures/django/"),
    os.path.join(BASE_DIR, "fixtures/fixtures/imported/"),
)

# Sites framework

SITE_ID = 1

# Webpack Django Loader

WEBPACK_LOADER = {
    "DEFAULT": {
        "BUNDLE_DIR_NAME": "webpack_bundles/",
        "STATS_FILE": os.path.join(BASE_DIR, "webpack-stats.json"),
    }
}

# Docuweb

DOCUWEB_SAFETY_NBYTES: int = 32

DEFAULT_AUTO_FIELD = "django.db.models.BigAutoField"

INTERNAL_IPS = [
    "127.0.0.1",
]
